package com.sun.java.swing.plaf.windows;

import java.awt.Dimension;
import java.awt.BorderLayout;
import javax.swing.UIManager;
import javax.swing.plaf.ComponentUI;
import javax.swing.JComponent;
import javax.swing.plaf.basic.BasicDesktopIconUI;

public class WindowsDesktopIconUI extends BasicDesktopIconUI
{
    private int width;
    
    public WindowsDesktopIconUI() {
    }
    
    public static ComponentUI createUI(JComponent component) {
        return new WindowsDesktopIconUI();
    }
    
    public void installDefaults() {
        super.installDefaults();
        this.width = UIManager.getInt("DesktopIcon.width");
    }
    
    @Override
    public void installUI(JComponent c) {
        super.installUI(c);
        c.setOpaque(XPStyle.getXP() == null);
    }
    
    @Override
    public void uninstallUI(JComponent c) {
        WindowsInternalFrameTitlePane windowsInternalFrameTitlePane = (WindowsInternalFrameTitlePane)this.iconPane;
        super.uninstallUI(c);
        windowsInternalFrameTitlePane.uninstallListeners();
    }
    
    @Override
    protected void installComponents() {
        this.iconPane = new WindowsInternalFrameTitlePane(this.frame);
        this.desktopIcon.setLayout(new BorderLayout());
        this.desktopIcon.add(this.iconPane, "Center");
        if (XPStyle.getXP() != null) {
            this.desktopIcon.setBorder(null);
        }
    }
    
    @Override
    public Dimension getPreferredSize(JComponent component) {
        return this.getMinimumSize(component);
    }
    
    @Override
    public Dimension getMinimumSize(JComponent c) {
        Dimension minimumSize = super.getMinimumSize(c);
        minimumSize.width = this.width;
        return minimumSize;
    }
}
